/*
 *
 * Common.h - dll include file - include this to get access to all exported functions
 * Date:	23.12.2002
 * Update:	-
 * Author:	Ondrej Burisin & Jiri Formanek
 *
 */

#ifndef _COMMON_H_
  #define _COMMON_H_  
  
  // If it is not defined, we define it as a import
  // Import exported func to external module
  #ifndef COMMON_API
    #define COMMON_API __declspec(dllimport)
  #endif

  #include "Symbols.h"	// Some macros
  #include "Strings.h"	// Strings defined as symbolic constants

  #include "CmnError.h"	// Common.DLL defined error codes  
  #include "CmnLog.h"	// Diagnostic  - TRACE
  #include "CmnFile.h"	// The file reading functions
  #include "CmnStg.h"	// Storage - IStream, IStorage
  #include "CmnStr.h"   // String functions
  #include "CmnInfo.h"	// Information about windows, system ...
  #include "CmnMisc.h"	// Misc functions ...
  #include "CmnZip.h"	// Compress and decompress functions

#endif // _COMMON_H_