// Hoare.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream.h>
#include <stdlib.h>
#include <time.h>

void TiskPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			cout << pPole[i] << " ";
		}

		cout << endl << endl;
	}
}

void NaplnPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			pPole[i] = rand() % 20;
		}
	}
}

void Hoare(int *pPole, int dwVel, int dwKty)
{
	int i, j, dwLevy, dwPravy;
	int iPom1, iPom2;			// vymeny prvku

	dwLevy = 0;
	dwPravy = dwVel - 1;
	
	while(dwLevy < dwPravy)
	{
		iPom1 = pPole[dwKty];
		i = dwLevy;
		j = dwPravy;

		// algoritmus rozdeleni podobne jako u algoritmu Quicksort
		do {
			while(pPole[i] < iPom1) { i++; }
			while(pPole[j] > iPom1) { j--; }

			if(i <= j)
			{
				iPom2 = pPole[i];
				pPole[i] = pPole[j];
				pPole[j] = iPom2;

				// posun na dalsi prvky
				i++;
				j--;
			}
		} while (i < j);	// cyklus konci, pokud doslo k prekrizeni indexu

		if(j < dwKty) { dwLevy = i; }
		if(dwKty < i) { dwPravy = j; }
	}
}

int Pole[20];

int main(int argc, char* argv[])
{
	srand((unsigned)time(NULL));	// abychom dostali pri kazdem spusteni jina cisla
	
	for(int i = 0; i < 3; i++)
	{
		cout << "Nesetrideno: " << endl;
		NaplnPole(Pole, 20);
		TiskPole(Pole, 20);
		Hoare(Pole, 20, 5);
		cout << "Nalezeny prvek: " << Pole[5] << endl;
		cout << "Setrideno: " << endl;
		TiskPole(Pole, 20);
		
	}

	char c;
	cin >> c;
	return 0;
}