#include "stdafx.h"

#include "Algoritmy.h"

void PrimyVyber(int *pPole, unsigned int dwVel)
{
	unsigned int dwNejmensi;	// index, ne hodnota !!!
	int iVymena;	// pro vymenu prvku

	for(unsigned int i = 0; i < (dwVel - 1); i++)
	{
		dwNejmensi = i;	// index prvku, ke kteremu hledame mensi

		for(unsigned int j = i + 1; j < dwVel; j++)	// hledame od dalsiho nesetrideneho
		{
			// najdeme index nejmensiho prvku, pokud existuje
			if(pPole[j] < pPole[dwNejmensi])
			{
				dwNejmensi = j;
			}
		}

		if(dwNejmensi > i)	// pokud jsme nasli mensi prvek
		{
			iVymena = pPole[i];
			pPole[i] = pPole[dwNejmensi];	// vymenime oba prvky
			pPole[dwNejmensi] = iVymena;
		}
	}
}

void Bublinka(int *pPole, unsigned int dwVel)
{
	int iVymena;

	for(unsigned int i = 1; i < dwVel; i++)
	{
		for(unsigned int j = dwVel - 1; j >= i; j--)	// pozor opraveno z minuleho dilu
		{
			if(pPole[j-1] > pPole[j])	// vetsi pred mensim
			{
				// prohodime prvky
				iVymena = pPole[j-1];
				pPole[j-1] = pPole[j];
				pPole[j] = iVymena;
			}
		}
	}
}

void Bublinka2(int *pPole, unsigned int dwVel)
{
	bool bProhoz = true;	// musi byt nastaveno, aby zacal cyklus
	int iVymena;

	// Budeme prochazet pole, dokud budou nastavat prohozeni
	while(bProhoz)
	{
		// pred pruchodem polem neni zadne prohozeni
		bProhoz = 0;
		
		// Zkontroluj vedle sebe lezici prvky
		for(unsigned int i = 0; i < (dwVel - 1); i++)
		{
			
			if(pPole[i] > pPole[i+1])	// vetsi pred mensim
			{
				// prohodime prvky
				iVymena = pPole[i+1];
				pPole[i+1] = pPole[i];
				pPole[i] = iVymena;

				bProhoz = true;	// nastala vymena
			}
		}
	}
}

void Pretres(int *pPole, unsigned int dwVel)
{
	unsigned int dwLevy = 1, dwPravy = dwVel - 1, dwVymena = dwVel - 1;
	int iVymena;

	do
	{
		for(unsigned int i = dwPravy; i >= dwLevy; i--)
		{
			if(pPole[i-1] > pPole[i])
			{
				iVymena = pPole[i-1];
				pPole[i-1] = pPole[i];	// vymena
				pPole[i] = iVymena;

				dwVymena = i;	// posledni vymena
			}
			
		}
		dwLevy = dwVymena+1;	// priste uz jen od posledniho vymeneneho prvku
		
		for(i = dwLevy; i <= dwPravy; i++)
		{
			if(pPole[i-1] > pPole[i])
			{
				iVymena = pPole[i-1];
				pPole[i-1] = pPole[i];	// vymena
				pPole[i] = iVymena;

				dwVymena = i;	// posledni vymena
			}
		}
		dwPravy = dwVymena - 1;
	} while(dwLevy <= dwPravy);
}

void PrimeVkladani(int *pPole, unsigned int dwVel)
{
	int j;	// pomocny index
	int iPomocna;	// pro vymenu prvku

	for(unsigned int i = 1; i < dwVel; i++)
	{
		iPomocna = pPole[i];	// prvek ktery zatridujeme
		j = i - 1;

		while((j >= 0) && (iPomocna < pPole[j]))
		{
			pPole[j+1] = pPole[j];	// posuny
			j--;	// jdeme na dalsi prvek
		}

		pPole[j+1] = iPomocna;	// spravna pozice pro zatridovany prvek
	}
}

void qsort(int *pPole, int dwLevy, int dwPravy)
{
	int	iPivot, iVymena;	// hodnota prvku zhruba uprostred a pomocna promenna na vymeny
	
	int i,j;	// pozor, nesmi byt unsigned, obcas potrebujeme i zaporne hodnoty
	
	i = dwLevy;
	j = dwPravy;	// indexy
	
	// zvoleni hodnoty pivotu - hodnota zhruba z prostredka pole
	iPivot = pPole[(dwLevy + dwPravy) / 2];	

	do {
		// hledame prvek, ktery nepatri na levou stranu pole
		// (tento prvek je tedy vetsi nezli hodnota iPivot)
		while(pPole[i] < iPivot) { i++; }
		
		// takovy prvek byl nalezen, nyni musime najit prvek, ktery nepatri do prave casti
		// (tento prvek je tedy mensi nezli hodnota iPivot
		while(pPole[j] > iPivot) { j--; }
		
		// pokud jsme se nedostali do opacne casti pole, tedy pokud se indexy neprekrizily, pak
		// prvky prohodime
		if(i <= j) {
			// prohodime prvky
			iVymena = pPole[i];
			pPole[i] = pPole[j];
			pPole[j] = iVymena;
			
			// dale se posuneme na dalsi prvky
			i++;
			j--;
		}
	} while(i < j);	// cyklus konci, pokud doslo k prekrizeni indexu
	
	// v dalsim kroku se pole rozdeli na dva useky, ktere setridime, pokud jsou ovsem v poradku indexy
	if(dwLevy < j) 
		qsort(pPole, dwLevy, j);

	if(i < dwPravy) 
		qsort(pPole, i, dwPravy);
}

void QuickSort(int *pPole, unsigned int dwVel)
{
	qsort(pPole, 0, dwVel - 1);
}

void msort(int *pPole, int *pPomPole, unsigned int dwLevy, unsigned int dwPravy) 
{
	unsigned int	dwStred;	// index prvku uprostred trideneho useku
	unsigned int i, j, k;	// indexy
	
	dwStred = (dwLevy + dwPravy) / 2;

	if(dwLevy < dwStred)
	{
		msort(pPole, pPomPole, dwLevy, dwStred);	// trideni leveho useku
	}
	if((dwStred + 1) < dwPravy)
	{
		msort(pPole, pPomPole, dwStred + 1, dwPravy);	// trideni praveho useku
	}

	// nyni budeme slucovat
	i = dwLevy;			// levy usek
	j = dwStred + 1;	// pravy usek
	k = dwLevy;			// index ve vyslednem poli

	// sloucime setridene useky do pomocneho pole
	while((i <= dwStred) && (j <= dwPravy))
	{
		if(pPole[i] <= pPole[j])
		{
			pPomPole[k] = pPole[i];
			i++;
		}
		else
		{
			pPomPole[k] = pPole[j];
			j++;
		}

		k++;
	}

	// dokopirujeme zbytek leveho useku
	while(i <= dwStred)
	{
		pPomPole[k] = pPole[i];
		i++;
		k++;
	}

	// dokopirujeme zbytek praveho useku
	while(j <= dwPravy)
	{
		pPomPole[k] = pPole[j];
		j++;
		k++;
	}

	// nyni preneseme setrideny usek z pomocneho pole zpet do puvodniho
	for(k = dwLevy; k <= dwPravy; k++)
	{
		pPole[k] = pPomPole[k];
	}
}

void MergeSort(int *pPole, unsigned int dwVel)
{
	// vytvorime pomocne pole
	int *pPomPole = new int[dwVel];

	if(pPomPole)
	{

		// utridime ho
		msort(pPole, pPomPole, 0, dwVel - 1);

		// docasne pole smazeme
		delete[] pPomPole;
	}
}

void ShellSort(int *pPole, unsigned int dwVel)
{
	unsigned int i, j, k;
	int iPomocna;			// vymeny prvku
    unsigned int krok[3];	// pole velikosti kroku
  
	// nastaveni velikosti kroku
	krok[0] = 4;
	krok[1] = 2;
	krok[2] = 1;
  
	for(unsigned int m = 0; m < 3; m++)
	{
		k = krok[m];	// zkopirujeme si velikost kroku se kterym prave pracujeme
		
		// provedeme trideni primym vkladanim
		for(i = k; i < dwVel; i++)
		{
			iPomocna = pPole[i];
			j = i;
		
			while((j >= k) && (iPomocna < pPole[j-k]))
			{
				pPole[j] = pPole[j - k];
				j -= k;
			}
     
			pPole[j] = iPomocna;
		}
	}
}

void csort(int *pPole, unsigned int dwVel, int iMaxPrvek)
{
	int *pC = new int[iMaxPrvek];	// pole pC obsahuje, kolikrat se vyskytuje cislo v poli
	int *pB = new int[dwVel + 1];

	// vynulujeme pole cetnosti
	for(int i = 0; i < iMaxPrvek; i++)
	{
		pC[i] = 0;
	}
	
	// projdeme postupne pole a spocteme vyskyt jednotlivych cisel
	for(unsigned int j = 0; j < dwVel; j++)
	{
		pC[pPole[j]]++;	// indexujeme primo cisly, ktera tridime
	}
	
	// provedeme secteni i-teho a predchazejiciho prvku v poli pC - pole pC bude obsahovat indexy prvku
	for(i = 1; i < iMaxPrvek; i++)
	{
		pC[i] += pC[i-1];
	}
	
	// tridene pole projdeme odzadu a budeme radit prvky podle indexu v poli pC
	for(i = dwVel-1; i >= 0; i--)
	{
		pB[pC[pPole[i]]] = pPole[i];
		pC[pPole[i]]--;
	}
	// v poli pB je vysledek, ktery prekopirujeme do puvodniho pole
	for(j = 0; j < dwVel; j++)
	{
		pPole[j] = pB[j + 1];
	}
	// smazeme pomocna pole
	delete [] pC;
	delete [] pB;
}

void CountingSort(int *pPole, unsigned int dwVel)
{
	csort(pPole, dwVel, MAXHODNOTA);
}






