// RychlTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <iomanip>
#include <time.h>

#include "Algoritmy.h"

using namespace std;

typedef void (*TRIDICIPROCEDURA)(int *pPole, unsigned int dwVel);	// procedura pro trideni

void TiskPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			cout << pPole[i] << " ";
		}

		cout << endl << endl;
	}
}

void NaplnPole(int *pPole, unsigned int dwVel, int iMaxHodnota)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			pPole[i] = rand() % iMaxHodnota;
		}
	}
}

bool OverPole(int *pPole, unsigned int dwVel)
{
	bool bRet = true;

	for(unsigned int i = 1; i < dwVel; i++)
	{
		if(pPole[i - 1] > pPole[i])	// predchozi prvek je vetsi nezli prvek nasledujici -> chyba algoritmu
		{
			bRet = false;	
			break;
		}
	}

	return bRet;
}


int main(int argc, char* argv[])
{
	srand((unsigned)time(NULL));	// abychom dostali pri kazdem spusteni jina cisla

	bool bKonec = false;
	unsigned int dwStart, dwStop;	// zacatek a konec trideni
	unsigned int dwMetoda = 0;	// volba
	int dwVel;	// velikost trideneho pole
	cout << "* Rychlostni test tridicich algoritmu *" << endl;

	while(dwMetoda != 10)
	{
		dwVel = 0;	// inicializace
		
		cout << "Zadej velikost trideneho pole (0 = konec): ";
		cin >> dwVel;
		
		if(dwVel <= 0) { break; } // 0 ukoncime

		// vytvorime dve pole - jedno tridene a druhe abychom mohli obnovit tridenou posloupnost
		int *pPole = new int[dwVel];	// pevne pole
		int *pPolePrac = new int[dwVel];	// pole ve kterem budeme tridit

		if(pPole && pPolePrac)
		{
			// naplneni pole nahodnymi cisly z rozmezi 0 - (MAXHODNOTA - 1)
			NaplnPole(pPole, dwVel, MAXHODNOTA);

			dwMetoda = 11;	// inicializace
			while(dwMetoda > 10)
			{
				cout << "0) Test vsech" << endl;
				cout << "1) Primy vyber (Select Sort)" << endl;
				cout << "2) Bublinkove trideni (Bubble Sort)" << endl;
				cout << "3) Bublinkove trideni 2 (Bubble Sort) - optimalizace" << endl;
				cout << "4) Pretrasani (Shake Sort)" << endl;
				cout << "5) Prime vkladani (Insert Sort)" << endl;
				cout << "6) Rychle trideni (Quick Sort)" << endl;
				cout << "7) Slucovani (Merge Sort)" << endl;
				cout << "8) Shellovo trideni (Shell Sort)" << endl;
				cout << "9) Vypocet poradi (Counting Sort)" << endl;
				cout << "10) Konec" << endl;
				cout << "Vyber metodu: ";
				
				cin >> dwMetoda;
			}

			TRIDICIPROCEDURA tridic;
			BOOL bTestVse = false;

			if(dwMetoda < 10)
			{
				while(1)	// nekonecny cyklus se obcas hodi :-)
				{
					if(0 == dwMetoda || bTestVse)
					{
						bTestVse = true;	// budem testovat vsechny
						
						if(dwMetoda < POCETMETOD)
						{
							dwMetoda++;	// posun na prvni metodu
						}
						else
						{
							dwMetoda = 11;	// nastavime puvodni, jinak bychom byli na 10 a doslo by k ukonceni programu
							break;	// jiz jsme prosli posledni metodou
						}
					}
						
					// obnoveni puvodniho pole
					for(int i = 0; i < dwVel; i++)
					{
						pPolePrac[i] = pPole[i];
					}

					switch(dwMetoda)
					{
						case 1: cout << "Primy vyber (Select Sort)" << endl;
								tridic = PrimyVyber;
								break;
						case 2: cout << "Bublinkove trideni (Bubble Sort)" << endl;
								tridic = Bublinka;
								break;
						case 3: cout << "Bublinkove trideni 2 (Bubble Sort) - optimalizace" << endl;
								tridic = Bublinka2;
								break;
						case 4: cout << "Pretrasani (Shake Sort)" << endl;
								tridic = Pretres;
								break;
						case 5: cout << "Prime vkladani (Insert Sort)" << endl;
								tridic = PrimeVkladani;
								break;
						case 6: cout << "Rychle trideni (Quick Sort)" << endl;
								tridic = QuickSort;
								break;
						case 7: cout << "Slucovani (Merge Sort)" << endl;
								tridic = MergeSort;
								break;
						case 8: cout << "Shellovo trideni (Shell Sort)" << endl;
								tridic = ShellSort;
								break;
						case 9: cout << "Vypocet poradi (Counting Sort)" << endl;
								tridic = CountingSort;
								break;
					}

					dwStart = GetTickCount();
					tridic(pPolePrac, dwVel);
					dwStop = GetTickCount();

					cout << "  Algoritmus setridil " << dwVel << " polozek v case " << dwStop - dwStart << " milisekund" << endl;
					cout << "  Kontrola pole probehla s vysledkem: " << (OverPole(pPolePrac, dwVel) ? "OK":"ERROR") << endl;

					if(!bTestVse) { break; }	// testujeme jen jeden algoritmus
				}
		    		
				delete[] pPole;
				delete[] pPolePrac;
			}
		}
	}

	return 0;
}
